#include "Wire.h"
 
#define TTP229_LSF 0x57 

int pwmRED=4;
int pwmGREEN=14;
int pwmBLUE=5;

int colors[][3]={{0,0,0},{0,0,0},
            {100,0,0},{100,100,0},{0,100,0},
            {0,100,100},{0,0,100},{100,0,100},
            {255,0,255},{255,0,0},{255,255,0},
            {0,255,0},{0,255,255},{0,0,255},
            {60,60,60},{150,150,150}};

void setup() {
  Wire.begin(0,2); // wake up I2C bus
  //Serial.begin(9600);
  pinMode(pwmRED,OUTPUT);
  pinMode(pwmGREEN,OUTPUT);
  pinMode(pwmBLUE,OUTPUT);
  analogWrite(pwmRED,0);
  analogWrite(pwmGREEN,0);
  analogWrite(pwmBLUE,0);
}
 
void getTTP229data(byte *a, byte *b) {
  Wire.requestFrom(TTP229_LSF, 2);    // request 2 bytes from slave device TTP229  
  int dataN = 0;
  while(Wire.available())    // slave may send less than requested
  { 
    char c = Wire.read();    // receive a byte as character 

    if (dataN == 0) *a = c;
    if (dataN == 1) *b = c;  
    dataN++;
  }

}
 
int getKey()
{
  byte aa,bb = 0;
  unsigned int mask=0x01;
  int key=0;
  
  getTTP229data(&aa,&bb);
  //printByte(aa);
  //printByte(bb);
  //Serial.println();
  for(int i=0;i<8;i++) {
     if(((mask<<i) & aa) > 0) {
        key=8-i;
        i=8;
     }
  }
  for(int i=0;i<8;i++) {
     if(((mask<<i) & bb) > 0) {
        key=16-i;
        i=8;
     }
  }
  return key;
}
 
void loop() {
  int k=getKey();
  if(k>0) {
    analogWrite(pwmRED,colors[k][0]);
    analogWrite(pwmGREEN,colors[k][1]);
    analogWrite(pwmBLUE,colors[k][2]);
  }
  delay(500);
}
 
void printByte (byte bytePrint) {
   for (unsigned int mask = 0x80; mask; mask >>= 1) {
       if (mask & bytePrint) {
           Serial.print('1');
       }
       else {
           Serial.print('0');
       }
   }
}



